# clover sitegen framework

this repository contains clover's "sitegen" framework, which is a set of tools
that assist building websites. these tools power https://paperclover.net.

- HTML "Server Side Rendering") engine written from scratch.
    - A more practical JSX runtime (`class` instead of `className`, etc).
    - Transparent integration with [Marko][1] to mix component types.
    - MDX support for text-heavy content pages.
- Incremental static site generator and build system
    - Build entire production site at start, incremental updates when pages
      change; Build system state survives coding sessions.
    - The only difference in development and production mode is hidden
      source-maps and stripped assertions and `console.debug` calls. The site
      you see locally is the site you see deployed.
- Built on the battle-tested Node.js runtime. Partial support for Deno and Bun.

[1]: https://next.markojs.com

